1
0
mirror of git://git.sv.gnu.org/coreutils.git synced 2026-03-03 03:25:26 +02:00
Files
coreutils/tests/misc/timeout.sh
Jim Meyering 04fc32f7e0 tests: use "env builtin" in place of "$abs_top_builddir/src/builtin"
This works for any program that might also be a shell built-in.
It is more concise.  In addition, it makes output more reproducible:
some diagnostics include argv[0], which will now be just the program
name, rather than the full absolute name of the executable.
* tests/misc/sort-compress.sh: Use env kill, rather than absolute name.
* tests/install/trap.sh: Likewise.
* tests/misc/timeout.sh: Likewise.
* tests/touch/no-dereference.sh: Do the same for two uses of "test".
* tests/touch/no-create-missing.sh: Likewise.
2014-07-02 09:07:26 -07:00

65 lines
1.8 KiB
Bash
Executable File

#!/bin/sh
# Validate timeout basic operation
# Copyright (C) 2008-2014 Free Software Foundation, Inc.
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
print_ver_ timeout
# no timeout
timeout 10 true || fail=1
# no timeout (suffix check)
timeout 1d true || fail=1
# disabled timeout
timeout 0 true || fail=1
# exit status propagation
timeout 10 sh -c 'exit 2'
test $? = 2 || fail=1
# timeout
timeout .1 sleep 10
test $? = 124 || fail=1
# exit status propagation even on timeout
timeout --preserve-status .1 sleep 10
# exit status should be 128+TERM
test $? = 124 && fail=1
# kill delay. Note once the initial timeout triggers,
# the exit status will be 124 even if the command
# exits on its own accord.
timeout -s0 -k1 .1 sleep 10
test $? = 124 && fail=1
# Ensure 'timeout' is immune to parent's SIGCHLD handler
# Use a subshell and an exec to work around a bug in FreeBSD 5.0 /bin/sh.
(
# ash doesn't support "trap '' CHLD"; it knows only signal numbers.
sig=$(env kill -l CHLD 2>/dev/null) && trap '' $sig
exec timeout 10 true
) || fail=1
# Don't be confused when starting off with a child (Bug#9098).
out=$(sleep .1 & exec timeout .5 sh -c 'sleep 2; echo foo')
status=$?
test "$out" = "" && test $status = 124 || fail=1
Exit $fail